Bio::Graphics::Glyph::stackedplot(3pm)

NAME
Bio::Graphics::Glyph::stackedplot - The stackedplot glyph

SYNOPSIS
  See L<Bio::Graphics::Panel> and L<Bio::Graphics::Glyph>.

DESCRIPTION
The stackedplot glyph can be used to draw quantitative feature data using a stacked column plot. It differs from the xyplot glyph in that the plot applies to a single top level feature, not a group of subfeatures. The data to be graphed is derived from an attribute called "data_series."

The data to be graphed is represented as a list of arrays:

 (
 [1, 2, 8],
 [6, 1, 1],
 [10,8, 0],
 [1, 1, 1],
 )

Each array is a column in the stacked plot. Its values become the subdivisions of the column. In this example, there are four columns, each of which has three subdivisions.

You can add labels to the columns and change the colors of the subdivisions.

To assign data to a feature, you can add a "series" tag:

 $snp1    = Bio::SeqFeature::Generic ->new (-start     => 500,-end=>501,
                                            -display_name =>'example',
                                            -tag=> { series => [
                                                             [10,20,30],
                                                             [30,30,0],
                                                             [5,45,10],
                                                             [5,45,10],
                                                             [5,45,10],
                                                             [50,0,50],
                                                            ],
                                                     }
                                               );

Note that the series tag must consist of an array of arrays.

If you are using a gff3 representation, you can load a database with data that looks like this:

 chr1 test feature 1 1000 . . . series=10 20 30;series=30 30 0;series=5 45 10...

If you are using a gff2 representation, you can load a database with data that looks like this:

 chr1 test feature 1 1000 . . . series 10 20 30; series 30 30 0 series 5 45 10...

Or you can pass a callback to the -series option:

 $panel->add_track(\@data,
                  -glyph     => 'stackedplot',
                  -series       => sub {
                                  my $feature = shift;
                             return [
                                [10,20,30],
                                [30,30,0],
                                [5,45,10],
                            ]
                          }
                 );

  OPTIONS
The following options are standard among all Glyphs. See Bio::Graphics::Glyph for a full explanation.

  Option      Description                      Default
  ------      -----------                      -------

  -fgcolor      Foreground color               black

  -outlinecolor Synonym for -fgcolor

  -bgcolor      Background color               turquoise

  -fillcolor    Synonym for -bgcolor

  -linewidth    Line width                     1

  -height       Height of glyph                10

  -font         Glyph font                     gdSmallFont

  -label        Whether to draw a label        0 (false)

  -description  Whether to draw a description  0 (false)

  -hilite       Highlight color                undef (no color)

In addition, the alignment glyph recognizes all the options of the xyplot glyph, as well as the following glyph-specific option:

  Option         Description                  Default
  ------         -----------                  -------

 -fixed_gap     Vertical distance between      8
                the rectangle that shows
                the start:end range of
                the feature and the fixed
                width stacked plot.

 -series_colors A list giving a series of     red,blue,green,orange,
                color names for the data      brown,grey,black
                series (the values inside
                each stacked column).

 -column_labels A list of labels to print     -none-
                underneath each column.

 -column_width  The width of each column.     8

 -column_spacing Spacing between each         2
                column.

 -min_score     Minimum score for the         0.0
                sum of the members of
                each data series.

 -max_score     Maximum score for the         1.0
                sum of the members of each
                data series.

 -scale_font    Font to use for the scale.    gdTinyFont

 -column_font   Font to use for the column    gdSmallFont
                labels.

 -draw_scale    Whether to draw a scale to    true
                right of the columns.

Note that -min_score and -max_score represent the minimum and maximum SUM of all the values in the data series. For example, if your largest column contains the series (10,20,30), then the -max_score is 60.

EXAMPLE
To understand how this glyph works, try running and modifying the following example:

 #!/usr/bin/perl

 use strict;
 use warnings;

 use Bio::Graphics;
 use Bio::SeqFeature::Generic;

 my $segment  = Bio::Graphics::Feature->new(-start=>1,-end=>700);

 my $snp1     = Bio::SeqFeature::Generic ->new (-start     => 500,-end=>590,
                                                -display_name =>'fred',
                                                -tag=> { series => [
                                                                     [10,20,30],
                                                                     [30,30,0],
                                                                     [5,45,10],
                                                                     [5,45,10],
                                                                     [5,45,10],
                                                                     [50,0,50],
                                                                    ],
                                                      },
                                                -source=>'A test',
                                                );

 my $snp2     = Bio::SeqFeature::Generic->new(-start     => 300,
                                              -end       => 301,
                                              -display_name  => 'rs12345',
                                              -tag=> {
                                                     series => [
                                                                     [30,20,10 ],
                                                                     [80,10,10 ],
                                                               ],
                                                    },
                                              -source=>'Another test',
                                            );

 my $panel = Bio::Graphics::Panel->new(-segment=>$segment,-width=>800);

 $panel->add_track($segment,-glyph=>'arrow',-double=>1,-tick=>2);
 $panel->add_track([$snp1,$snp2],
                   -height    => 50,
                   -glyph     => 'stackedplot',
                   -fixed_gap => 12,
                   -series_colors    => [qw(red blue lavender)],
                   -column_labels => [qw(a b c d e f g)],
                   -min_score => 0,
                   -max_score => 100,
                   -column_width => 8,
                   -column_font  => 'gdMediumBoldFont',
                   -scale_font   => 'gdTinyFont',
                   -label    => 1,
                   -description=>1,
                  );
 print $panel->png;

BUGS
Please report them.

SEE ALSO
Bio::Graphics::Panel, Bio::Graphics::Track, Bio::Graphics::Glyph::transcript2, Bio::Graphics::Glyph::anchored_arrow, Bio::Graphics::Glyph::arrow, Bio::Graphics::Glyph::box, Bio::Graphics::Glyph::primers, Bio::Graphics::Glyph::segments, Bio::Graphics::Glyph::toomany, Bio::Graphics::Glyph::transcript,

AUTHOR
Lincoln Stein <lstein@cshl.org>

Copyright (c) 2006 Cold Spring Harbor Laboratory

This library is free software; you can redistribute it and/or modify it under the same terms as Perl itself. See DISCLAIMER.txt for disclaimers of warranty.